Index: src/network/core/tcp.h
===================================================================
--- src/network/core/tcp.h	(revision 13683)
+++ src/network/core/tcp.h	(working copy)
@@ -55,6 +55,7 @@
 	PACKET_CLIENT_RCON,
 	PACKET_SERVER_CHECK_NEWGRFS,
 	PACKET_CLIENT_NEWGRFS_CHECKED,
+	PACKET_CLIENT_MOVE,
 	PACKET_END                   ///< Must ALWAYS be on the end of this list!! (period)
 };
 
Index: src/network/network_func.h
===================================================================
--- src/network/network_func.h	(revision 13683)
+++ src/network/network_func.h	(working copy)
@@ -53,9 +53,11 @@
 NetworkClientInfo *NetworkFindClientInfoFromIP(const char *ip);
 const char* GetPlayerIP(const NetworkClientInfo *ci);
 
+void NetworkServerSendMove(uint16 client_index, PlayerID new_player);
 void NetworkServerSendRcon(uint16 client_index, ConsoleColour colour_code, const char *string);
 void NetworkServerSendError(uint16 client_index, NetworkErrorCode error);
 void NetworkServerSendChat(NetworkAction action, DestType type, int dest, const char *msg, uint16 from_index);
+void NetworkServerSendMuteStatus(uint16 client_index);
 
 #define FOR_ALL_ACTIVE_CLIENT_INFOS(ci) for (ci = _network_client_info; ci != endof(_network_client_info); ci++) if (ci->client_index != NETWORK_EMPTY_INDEX)
 
Index: src/network/network_server.cpp
===================================================================
--- src/network/network_server.cpp	(revision 13683)
+++ src/network/network_server.cpp	(working copy)
@@ -58,6 +58,7 @@
 		p->Send_uint8 (ci->client_playas);
 		p->Send_string(ci->client_name);
 		p->Send_string(ci->unique_id);
+		p->Send_uint8(ci->mute);
 
 		cs->Send_Packet(p);
 	}
@@ -599,6 +600,17 @@
 	cs->Send_Packet(p);
 }
 
+DEF_SERVER_SEND_COMMAND_PARAM(PACKET_CLIENT_MOVE)(NetworkTCPSocketHandler *cs, uint16 client_index, PlayerID new_player)
+{
+	Packet *p = NetworkSend_Init(PACKET_CLIENT_MOVE);
+
+	DEBUG(net, 0, "[move] client %d to player %d", client_index, min(new_player+1, PLAYER_SPECTATOR));
+
+	p->Send_uint16(client_index);
+	p->Send_uint8(new_player);
+	cs->Send_Packet(p);
+}
+
 // **********
 // Receiving functions
 //   DEF_SERVER_RECEIVE_COMMAND has parameter: NetworkTCPSocketHandler *cs, Packet *p
@@ -893,6 +905,12 @@
 		return;
 	}
 
+	/* handle terraform commands */
+	if ((cp->cmd & 0xff) == CMD_TERRAFORM_LAND || (cp->cmd & 0xff) == CMD_LEVEL_LAND) {
+		if (!HasBit(_settings_game.construction.allow_terraform, cp->player)) return;
+		DEBUG(misc, 1, "Client %u (Player %u) terraformed tile %x", ci->client_index, cp->player, cp->tile);
+	}
+
 	if (!CheckCommandFlags(cp, ci)) {
 		SEND_COMMAND(PACKET_SERVER_ERROR)(cs, NETWORK_ERROR_KICKED);
 		free(cp);
@@ -1061,10 +1079,12 @@
 void NetworkServerSendChat(NetworkAction action, DestType desttype, int dest, const char *msg, uint16 from_index)
 {
 	NetworkTCPSocketHandler *cs;
-	const NetworkClientInfo *ci, *ci_own, *ci_to;
+	const NetworkClientInfo *ci, *ci_own, *ci_to, *ci_from;
+	ci_from = NetworkFindClientInfoFromIndex(from_index);
 
 	switch (desttype) {
 	case DESTTYPE_CLIENT:
+		if (ci_from != NULL && HasBit(ci_from->mute, 3)) break;
 		/* Are we sending to the server? */
 		if (dest == NETWORK_SERVER_INDEX) {
 			ci = NetworkFindClientInfoFromIndex(from_index);
@@ -1101,6 +1121,7 @@
 	case DESTTYPE_TEAM: {
 		bool show_local = true; // If this is false, the message is already displayed
 														// on the client who did sent it.
+		if (ci_from != NULL && HasBit(ci_from->mute, 2)) break;
 		/* Find all clients that belong to this player */
 		ci_to = NULL;
 		FOR_ALL_CLIENTS(cs) {
@@ -1145,6 +1166,7 @@
 		DEBUG(net, 0, "[server] received unknown chat destination type %d. Doing broadcast instead", desttype);
 		/* fall-through to next case */
 	case DESTTYPE_BROADCAST:
+		if (ci_from != NULL && HasBit(ci_from->mute, 1)) break;
 		FOR_ALL_CLIENTS(cs) {
 			SEND_COMMAND(PACKET_SERVER_CHAT)(cs, action, from_index, false, msg);
 		}
@@ -1284,6 +1306,7 @@
 	RECEIVE_COMMAND(PACKET_CLIENT_RCON),
 	NULL, /*PACKET_CLIENT_CHECK_NEWGRFS,*/
 	RECEIVE_COMMAND(PACKET_CLIENT_NEWGRFS_CHECKED),
+	NULL /*PACKET_CLIENT_MOVE,*/
 };
 
 // If this fails, check the array above with network_data.h
@@ -1676,6 +1699,11 @@
 	}
 }
 
+void NetworkServerSendMove(uint16 client_index, PlayerID new_player)
+{
+	SEND_COMMAND(PACKET_CLIENT_MOVE)(NetworkFindClientStateFromIndex(client_index), client_index, new_player);
+}
+
 void NetworkServerSendRcon(uint16 client_index, ConsoleColour colour_code, const char *string)
 {
 	SEND_COMMAND(PACKET_SERVER_RCON)(NetworkFindClientStateFromIndex(client_index), colour_code, string);
@@ -1696,4 +1724,10 @@
 	}
 	return false;
 }
+
+void NetworkServerSendMuteStatus(uint16 client_index) 
+{
+	if (NetworkFindClientStateFromIndex(client_index)->status != STATUS_ACTIVE) return;
+	NetworkUpdateClientInfo(client_index);
+}
 #endif /* ENABLE_NETWORK */
Index: src/network/network_server.h
===================================================================
--- src/network/network_server.h	(revision 13683)
+++ src/network/network_server.h	(working copy)
@@ -13,6 +13,7 @@
 DEF_SERVER_SEND_COMMAND(PACKET_SERVER_SHUTDOWN);
 DEF_SERVER_SEND_COMMAND(PACKET_SERVER_NEWGAME);
 DEF_SERVER_SEND_COMMAND_PARAM(PACKET_SERVER_RCON)(NetworkTCPSocketHandler *cs, uint16 color, const char *command);
+DEF_SERVER_SEND_COMMAND_PARAM(PACKET_CLIENT_MOVE)(NetworkTCPSocketHandler *cs, uint16 client_index, uint8 player_index);
 
 bool NetworkServer_ReadPackets(NetworkTCPSocketHandler *cs);
 void NetworkServer_Tick(bool send_frame);
Index: src/network/network_client.cpp
===================================================================
--- src/network/network_client.cpp	(revision 13683)
+++ src/network/network_client.cpp	(working copy)
@@ -7,6 +7,7 @@
 #include "../stdafx.h"
 #include "../debug.h"
 #include "../openttd.h"
+#include "../gfx_func.h"
 #include "network_internal.h"
 #include "core/tcp.h"
 #include "network_client.h"
@@ -27,7 +28,6 @@
 #include "../player_base.h"
 #include "../player_gui.h"
 #include "../rev.h"
-
 #include "table/strings.h"
 
 // This file handles all the client-commands
@@ -129,6 +129,9 @@
 	_network_join_status = NETWORK_JOIN_STATUS_AUTHORIZING;
 	InvalidateWindow(WC_NETWORK_STATUS_WINDOW, 0);
 
+	/* force clients to join as PLAYER_SPECTATOR */
+	_network_playas = PLAYER_SPECTATOR;
+
 	p = NetworkSend_Init(PACKET_CLIENT_JOIN);
 	p->Send_string(_openttd_revision);
 	p->Send_string(_settings_client.network.player_name); // Player name
@@ -396,6 +399,7 @@
 //  which is always an unique number on a server.
 DEF_CLIENT_RECEIVE_COMMAND(PACKET_SERVER_CLIENT_INFO)
 {
+	const Player *player;
 	NetworkClientInfo *ci;
 	uint16 index = p->Recv_uint16();
 	PlayerID playas = (Owner)p->Recv_uint8();
@@ -404,6 +408,7 @@
 
 	p->Recv_string(name, sizeof(name));
 	p->Recv_string(unique_id, sizeof(unique_id));
+	byte muted = (byte)p->Recv_uint8();
 
 	if (MY_CLIENT->has_quit) return NETWORK_RECV_STATUS_CONN_LOST;
 
@@ -416,14 +421,34 @@
 			// Client name changed, display the change
 			NetworkTextMessage(NETWORK_ACTION_NAME_CHANGE, CC_DEFAULT, false, ci->client_name, "%s", name);
 		} else if (playas != ci->client_playas) {
-			// The player changed from client-player..
-			// Do not display that for now
+			/* Client has been moved to another company or to spectator, show a message. */
+			if (ci->client_playas != PLAYER_NEW_COMPANY && ci->client_playas != PLAYER_INACTIVE_CLIENT) {
+				/* if not valid player, force spectator, else check player exists */
+				if (!IsValidPlayer(playas)) {
+					playas = PLAYER_SPECTATOR;
+				} else {
+					/* only if it's a valid player, actually get the player and check it */
+					player = GetPlayer(playas);
+					if (!player->is_active) {
+						playas = PLAYER_SPECTATOR;
+					}
+				}
+				
+				if (playas == PLAYER_SPECTATOR || playas > MAX_PLAYERS) {
+					NetworkTextMessage(NETWORK_ACTION_SERVER_MESSAGE, CC_DEFAULT, false, ci->client_name, "'%s' Moved To Spectators", ci->client_name);
+				} else {
+					NetworkTextMessage(NETWORK_ACTION_SERVER_MESSAGE, CC_DEFAULT, false, ci->client_name, "'%s' Moved To Company #%d", ci->client_name, playas+1);
+				}
+			}
 		}
 
 		ci->client_playas = playas;
 		ttd_strlcpy(ci->client_name, name, sizeof(ci->client_name));
+		ci->mute = muted;
 
 		InvalidateWindow(WC_CLIENT_LIST, 0);
+		InvalidateWindow(WC_MOVE_PLAYER, 0);
+		InvalidateWindow(WC_MUTE_PLAYER, 0);
 
 		return NETWORK_RECV_STATUS_OKAY;
 	}
@@ -857,6 +882,51 @@
 	return NETWORK_RECV_STATUS_OKAY;
 }
 
+DEF_CLIENT_RECEIVE_COMMAND(PACKET_CLIENT_MOVE)
+{
+	const Player *player;
+	uint16 client_index;
+	PlayerID player_index;
+	
+	/* Nothing more in this packet... */
+	client_index = p->Recv_uint16();
+	player_index = (Owner)p->Recv_uint8();
+	
+	if (client_index == 0) {
+		/* deffinately an invalide client id, debug message and do nothing. */
+		DEBUG(net, 0, "[move] received client index = 0");
+		return NETWORK_RECV_STATUS_OKAY;
+	}
+	
+	const NetworkClientInfo *ci = NetworkFindClientInfoFromIndex(client_index);
+	/* Just make sure we do not try to use a client_index that does not exist */
+	if (ci != NULL) {
+		/* if not valid player, force spectator, else check player exists */
+		if (!IsValidPlayer(player_index)) {
+			player_index = PLAYER_SPECTATOR;
+		} else {
+			/* only if it's a valid player, actually get the player and check it */
+			player = GetPlayer(player_index);
+			if (!player->is_active) {
+				player_index = PLAYER_SPECTATOR;
+			}
+		}
+		
+		if (client_index == _network_own_client_index) {
+			/* this packet is actually for this client... apply the new player_index */
+			DEBUG(net, 0, "[move] client %d to player %d", client_index, min(player_index+1, PLAYER_SPECTATOR));
+			
+			_network_playas = player_index;
+			SetLocalPlayer(player_index);
+			
+			/* Disable any buttons in any windows the client is now not supposed to get to, and do it fast. */
+			/* If this is not done fast enough, it can cause the client to be kicked or have an assert! */
+			MarkWholeScreenDirty();
+		}
+	}
+	
+	return NETWORK_RECV_STATUS_OKAY;
+}
 
 
 // The layout for the receive-functions by the client
@@ -901,6 +971,7 @@
 	NULL, /*PACKET_CLIENT_RCON,*/
 	RECEIVE_COMMAND(PACKET_SERVER_CHECK_NEWGRFS),
 	NULL, /*PACKET_CLIENT_NEWGRFS_CHECKED,*/
+	RECEIVE_COMMAND(PACKET_CLIENT_MOVE),
 };
 
 // If this fails, check the array above with network_data.h
Index: src/network/network_gui.cpp
===================================================================
--- src/network/network_gui.cpp	(revision 13683)
+++ src/network/network_gui.cpp	(working copy)
@@ -31,6 +31,9 @@
 #include "../widgets/dropdown_func.h"
 #include "../querystring_gui.h"
 #include "../sortlist_type.h"
+#include "../player_base.h"
+#include "../debug.h"
+#include "../console_func.h"
 
 #include "table/strings.h"
 #include "../table/sprites.h"
@@ -43,6 +46,10 @@
 static void ShowNetworkStartServerWindow();
 static void ShowNetworkLobbyWindow(NetworkGameList *ngl);
 extern void SwitchMode(int new_mode);
+static void ShowMovePlayerWindow();
+byte _current_move_window_client;
+byte _current_mute_window_client;
+static void ShowMutePlayerWindow();
 
 static const StringID _connection_types_dropdown[] = {
 	STR_NETWORK_LAN_INTERNET,
@@ -1183,10 +1190,10 @@
 
 static const Widget _client_list_widgets[] = {
 {   WWT_CLOSEBOX,   RESIZE_NONE,    14,     0,    10,     0,    13, STR_00C5,                 STR_018B_CLOSE_WINDOW},
-{    WWT_CAPTION,   RESIZE_NONE,    14,    11,   237,     0,    13, STR_NETWORK_CLIENT_LIST,  STR_018C_WINDOW_TITLE_DRAG_THIS},
-{  WWT_STICKYBOX,   RESIZE_NONE,    14,   238,   249,     0,    13, STR_NULL,                 STR_STICKY_BUTTON},
+{    WWT_CAPTION,   RESIZE_NONE,    14,    11,   287,     0,    13, STR_NETWORK_CLIENT_LIST,  STR_018C_WINDOW_TITLE_DRAG_THIS},
+{  WWT_STICKYBOX,   RESIZE_NONE,    14,   288,   299,     0,    13, STR_NULL,                 STR_STICKY_BUTTON},
 
-{      WWT_PANEL,   RESIZE_NONE,    14,     0,   249,    14,    14 + CLNWND_ROWSIZE + 1, 0x0, STR_NULL},
+{      WWT_PANEL,   RESIZE_NONE,    14,     0,   299,    14,    14 + CLNWND_ROWSIZE + 1, 0x0, STR_NULL},
 {   WIDGETS_END},
 };
 
@@ -1196,7 +1203,7 @@
 };
 
 static const WindowDesc _client_list_desc = {
-	WDP_AUTO, WDP_AUTO, 250, 1, 250, 1,
+	WDP_AUTO, WDP_AUTO, 300, 1, 300, 1,
 	WC_CLIENT_LIST, WC_NONE,
 	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_STICKY_BUTTON,
 	_client_list_widgets,
@@ -1218,12 +1225,28 @@
 // Here we start to define the options out of the menu
 static void ClientList_Kick(byte client_no)
 {
-	if (client_no < MAX_PLAYERS)
-		SEND_COMMAND(PACKET_SERVER_ERROR)(DEREF_CLIENT(client_no), NETWORK_ERROR_KICKED);
+	char kick_rcon_command[15];
+	if (client_no < MAX_PLAYERS) {
+	
+		if (_network_server) {
+			SEND_COMMAND(PACKET_SERVER_ERROR)(DEREF_CLIENT(client_no), NETWORK_ERROR_KICKED);
+		}
+		else if (_networking && _settings_client.network.rcon_password[0] != '\0') {
+			sprintf(kick_rcon_command, "kick %d", DEREF_CLIENT_INFO(DEREF_CLIENT(client_no))->client_index);
+			NetworkClientSendRcon(_settings_client.network.rcon_password, kick_rcon_command);
+		}
+	}
 }
 
 static void ClientList_Ban(byte client_no)
 {
+	char ban_rcon_command[15];
+	if (_networking && _settings_client.network.rcon_password[0] != '\0') {
+		sprintf(ban_rcon_command, "ban %d", DEREF_CLIENT_INFO(DEREF_CLIENT(client_no))->client_index);
+		NetworkClientSendRcon(_settings_client.network.rcon_password, ban_rcon_command);
+		return;
+	}
+	
 	uint32 ip = NetworkFindClientInfo(client_no)->client_ip;
 
 	for (uint i = 0; i < lengthof(_network_ban_list); i++) {
@@ -1264,6 +1287,18 @@
 	ShowNetworkChatQueryWindow(DESTTYPE_BROADCAST, 0);
 }
 
+static void ClientList_Move(byte client_no)
+{
+	_current_move_window_client = client_no;
+	ShowMovePlayerWindow();
+}
+
+static void ClientList_Mute(byte client_no)
+{
+	_current_mute_window_client = client_no;
+	ShowMutePlayerWindow();
+}
+
 static void ClientList_None(byte client_no)
 {
 	/* No action ;) */
@@ -1286,20 +1321,22 @@
 		 * Watch is, max 50 chars long!
 		 */
 
-		const NetworkClientInfo *ci = NetworkFindClientInfo(client_no);
+		const NetworkClientInfo *ci = NetworkFindClientInfo(client_no), *own_ci = NetworkFindClientInfoFromIndex(_network_own_client_index);
 
 		int i = 0;
-		if (_network_own_client_index != ci->client_index) {
+		if (_network_own_client_index != ci->client_index && !HasBit(own_ci->mute, 3)) {
 			GetString(this->action[i], STR_NETWORK_CLIENTLIST_SPEAK_TO_CLIENT, lastof(this->action[i]));
 			this->proc[i++] = &ClientList_SpeakToClient;
 		}
 
-		if (IsValidPlayer(ci->client_playas) || ci->client_playas == PLAYER_SPECTATOR) {
+		if (IsValidPlayer(ci->client_playas) || ci->client_playas == PLAYER_SPECTATOR && !HasBit(own_ci->mute, 2)) {
 			GetString(this->action[i], STR_NETWORK_CLIENTLIST_SPEAK_TO_COMPANY, lastof(this->action[i]));
 			this->proc[i++] = &ClientList_SpeakToCompany;
 		}
-		GetString(this->action[i], STR_NETWORK_CLIENTLIST_SPEAK_TO_ALL, lastof(this->action[i]));
-		this->proc[i++] = &ClientList_SpeakToAll;
+		if (!HasBit(own_ci->mute, 1)) {
+			GetString(this->action[i], STR_NETWORK_CLIENTLIST_SPEAK_TO_ALL, lastof(this->action[i]));
+			this->proc[i++] = &ClientList_SpeakToAll;
+		}
 
 		if (_network_own_client_index != ci->client_index) {
 			/* We are no spectator and the player we want to give money to is no spectator and money gifts are allowed */
@@ -1308,15 +1345,27 @@
 				this->proc[i++] = &ClientList_GiveMoney;
 			}
 		}
+		
 
+
 		/* A server can kick clients (but not himself) */
-		if (_network_server && _network_own_client_index != ci->client_index) {
+		if ((_network_server && _network_own_client_index != ci->client_index) || (_settings_client.network.rcon_password[0] != '\0' && ci->client_index != NETWORK_SERVER_INDEX && ci->client_index != _network_own_client_index)) {
 			GetString(this->action[i], STR_NETWORK_CLIENTLIST_KICK, lastof(this->action[i]));
 			this->proc[i++] = &ClientList_Kick;
 
 			sprintf(this->action[i],"Ban"); // XXX GetString?
 			this->proc[i++] = &ClientList_Ban;
 		}
+		
+		if ((_network_server || (_settings_client.network.rcon_password[0] != 0)) && ci->client_index != NETWORK_SERVER_INDEX) {
+			GetString(this->action[i], STR_NETWORK_CLIENTLIST_MOVE, lastof(this->action[i]));
+			this->proc[i++] = &ClientList_Move;
+		}
+		
+		if (ci->client_index != NETWORK_SERVER_INDEX && _network_own_client_index != ci->client_index && (_network_server || (_settings_client.network.rcon_password[0] != 0))) {
+			GetString(this->action[i], STR_NETWORK_CLIENTLIST_MUTE, lastof(this->action[i]));
+			this->proc[i++] = &ClientList_Mute;
+		}
 
 		if (i == 0) {
 			GetString(this->action[i], STR_NETWORK_CLIENTLIST_NONE, lastof(this->action[i]));
@@ -1493,9 +1542,14 @@
 
 			/* Filter out spectators */
 			if (IsValidPlayer(ci->client_playas)) DrawPlayerIcon(ci->client_playas, 64, y + 1);
+						
+			char id_line[20];
+ 			char name_line[52];
+			sprintf(id_line,"#%d", ci->client_index);
+			sprintf(name_line,": %s", ci->client_name);
+			DoDrawString(id_line, 87, y, colour);
+			DoDrawString(name_line, 127, y, colour);
 
-			DoDrawString(ci->client_name, 81, y, colour);
-
 			y += CLNWND_ROWSIZE;
 		}
 	}
@@ -1876,6 +1930,7 @@
 void ShowNetworkChatQueryWindow(DestType type, int dest)
 {
 	DeleteWindowById(WC_SEND_NETWORK_MSG, 0);
+	if (HasBit(NetworkFindClientInfoFromIndex(_network_own_client_index)->mute, type + 1)) return;
 	new NetworkChatWindow (&_chat_window_desc, type, dest);
 }
 
@@ -1983,9 +2038,171 @@
 
 void ShowNetworkCompanyPasswordWindow(Window *parent)
 {
-	DeleteWindowById(WC_COMPANY_PASSWORD_WINDOW, 0);
+	DeleteWindowById(WC_MOVE_PLAYER, 0);
 
 	new NetworkCompanyPasswordWindow(&_ncp_window_desc, parent);
 }
 
+enum MovePlayerWindowWidgets {
+	MPW_CLOSE,
+	MPW_CAPTION,
+	MPW_BACKGROUND,
+	MPW_SPECTATORS,
+	MPW_FIRST_COMPANY,
+	MPW_LAST_COMPANY = 11
+};
+
+struct MovePlayerWindow : Window {
+	MovePlayerWindow(const WindowDesc *desc, WindowNumber window_number) : Window(desc, window_number)
+	{
+		this->FindWindowPlacementAndResize(desc);
+	}
+
+	virtual void OnPaint()
+	{
+		const Player *p;
+
+
+		this->DrawWidgets();
+		NetworkClientInfo *move_ci = DEREF_CLIENT_INFO(DEREF_CLIENT(_current_move_window_client));
+
+		FOR_ALL_PLAYERS(p) {
+			if (!p->is_active) continue;
+
+			DrawPlayerIcon(p->index, 4, 18 + (p->index+1) * 12);
+
+			SetDParam(0, p->index);
+			SetDParam(1, p->index);
+			
+			DrawString(21, 17 + (p->index+1) * 12, STR_7021, TC_WHITE);
+			if (move_ci->client_playas == p->index) this->LowerWidget(p->index + MPW_FIRST_COMPANY);
+		}
+		if (move_ci->client_playas == PLAYER_SPECTATOR) this->LowerWidget(MPW_SPECTATORS);
+		DrawString(21, 17, STR_MOVE_PLAYER_SPECTATORS, TC_WHITE);
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		if (!IsInsideMM(widget, MPW_SPECTATORS, MPW_LAST_COMPANY + 1)) return;
+		PlayerID PId;
+		char move_rcon_command[20];
+		NetworkClientInfo *move_ci = DEREF_CLIENT_INFO(DEREF_CLIENT(_current_move_window_client));
+		if (widget == MPW_SPECTATORS) PId = PLAYER_SPECTATOR;
+		else {
+			PId = (PlayerID)(widget - 4);
+		}
+		if (PId == move_ci->client_playas) return;
+		if (IsValidPlayer(PId) && GetPlayer(PId)->is_active || PId == PLAYER_SPECTATOR) {
+			DEBUG(misc, 0, "widget: %d playerid: %d", widget, PId);
+			if (PId ==PLAYER_SPECTATOR) sprintf(move_rcon_command, "move %d", move_ci->client_index);
+			else sprintf(move_rcon_command, "move %d %d", move_ci->client_index, PId + 1);
+			if (_network_server) {
+				IConsoleCmdExec(move_rcon_command);
+			}
+			else {
+				NetworkClientSendRcon(_settings_client.network.rcon_password, move_rcon_command);
+			}
+		}
+		else return;
+		DeleteWindowById(WC_MOVE_PLAYER, 0);
+	}
+};
+
+static const Widget _move_player_widgets[] = {
+{   WWT_CLOSEBOX,   RESIZE_NONE,    14,     0,    10,     0,    13, STR_00C5,                       STR_018B_CLOSE_WINDOW},
+{    WWT_CAPTION,   RESIZE_NONE,    14,    11,   249,     0,    13, STR_MOVE_PLAYER_CAPTION, STR_018C_WINDOW_TITLE_DRAG_THIS},
+{      WWT_PANEL,   RESIZE_NONE,    14,     0,   249,    14,   125, 0x0,                            STR_NULL},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    16,    27, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    28,    39, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    40,    51, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    52,    63, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    64,    75, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    76,    87, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    88,    99, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,   100,   111, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,   112,   123, 0x0,                            STR_MOVE_PLAYER_TOOLTIP},
+{   WIDGETS_END},
+};
+
+static const WindowDesc _move_player_desc = {
+	WDP_AUTO, WDP_AUTO, 250, 126, 250, 126,
+	WC_MOVE_PLAYER, WC_NONE,
+	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET,
+	_move_player_widgets,
+};
+
+static void ShowMovePlayerWindow()
+{
+	DeleteWindowById(WC_MOVE_PLAYER, 0);
+	AllocateWindowDescFront<MovePlayerWindow>(&_move_player_desc, 0);
+}
+
+enum MutePlayerWindowWidgets {
+	MUPW_CLOSE,
+	MUPW_CAPTION,
+	MUPW_BACKGROUND,
+	MUPW_BROADCAST,
+	MUPW_TEAM,
+	MUPW_CLIENT
+};
+
+struct MutePlayerWindow : Window {
+	MutePlayerWindow(const WindowDesc *desc, WindowNumber window_number) : Window(desc, window_number)
+	{
+		this->FindWindowPlacementAndResize(desc);
+	}
+
+	virtual void OnPaint()
+	{
+
+		NetworkClientInfo *mute_ci = DEREF_CLIENT_INFO(DEREF_CLIENT(_current_mute_window_client));
+		assert(mute_ci != NULL);
+		this->SetWidgetLoweredState(MUPW_BROADCAST, HasBit(mute_ci->mute, 1));
+		this->SetWidgetLoweredState(MUPW_TEAM, HasBit(mute_ci->mute, 2));
+		this->SetWidgetLoweredState(MUPW_CLIENT, HasBit(mute_ci->mute, 3));
+		this->DrawWidgets();
+		DrawString(21,17 + 0 * 12, STR_MUTE_PLAYER_ALL, TC_WHITE);
+		DrawString(21, 17 + 1 * 12, STR_MUTE_PLAYER_TEAM, TC_WHITE);
+		DrawString(21, 17 + 2 * 12, STR_MUTE_PLAYER_PRIVATE, TC_WHITE);
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		if (!IsInsideMM(widget, MUPW_BROADCAST, MUPW_CLIENT + 1)) return;
+		NetworkClientInfo *mute_ci = DEREF_CLIENT_INFO(DEREF_CLIENT(_current_mute_window_client));
+		char mute_rcon_command[12];
+		byte clicked = widget - MUPW_BROADCAST + 1;
+		sprintf(mute_rcon_command, "mute %d %d", mute_ci->client_index, clicked);
+		if (_network_server) {
+			IConsoleCmdExec(mute_rcon_command);
+		}
+		else if (_networking && _settings_client.network.rcon_password[0] != '\0'){
+			NetworkClientSendRcon(_settings_client.network.rcon_password, mute_rcon_command);
+		}
+	}
+};
+
+static const Widget _mute_player_widgets[] = {
+{   WWT_CLOSEBOX,   RESIZE_NONE,    14,     0,    10,     0,    13, STR_00C5,                       STR_018B_CLOSE_WINDOW},
+{    WWT_CAPTION,   RESIZE_NONE,    14,    11,   249,     0,    13, STR_MUTE_PLAYER_CAPTION, STR_018C_WINDOW_TITLE_DRAG_THIS},
+{      WWT_PANEL,   RESIZE_NONE,    14,     0,   249,    14,   53, 0x0,                                            STR_NULL},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    16,    27, 0x0,                            STR_MUTE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    28,    39, 0x0,                            STR_MUTE_PLAYER_TOOLTIP},
+{      WWT_PANEL,   RESIZE_NONE,    14,     2,   247,    40,    51, 0x0,                            STR_MUTE_PLAYER_TOOLTIP},
+{   WIDGETS_END},
+};
+
+static const WindowDesc _mute_player_desc = {
+	WDP_AUTO, WDP_AUTO, 250, 54, 250, 54,
+	WC_MUTE_PLAYER, WC_NONE,
+	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET,
+	_mute_player_widgets,
+};
+
+static void ShowMutePlayerWindow()
+{
+	DeleteWindowById(WC_MUTE_PLAYER, 0);
+	AllocateWindowDescFront<MutePlayerWindow>(&_mute_player_desc, 0);
+}
+
 #endif /* ENABLE_NETWORK */
Index: src/yapf/follow_track.hpp
===================================================================
--- src/yapf/follow_track.hpp	(revision 13683)
+++ src/yapf/follow_track.hpp	(working copy)
@@ -6,7 +6,9 @@
 #define  FOLLOW_TRACK_HPP
 
 #include "yapf.hpp"
+#include "../rail_map.h"
 #include "../depot_map.h"
+#include "../sharedinfrastructure.h"
 
 /** Track follower helper template class (can serve pathfinders and vehicle
  *  controllers). See 6 different typedefs below for 3 different transport
@@ -217,12 +219,13 @@
 				return false;
 			}
 		}
-
-		/* single tram bits can only be entered from one direction */
-		DiagDirection single_tram = GetSingleTramBit(m_new_tile);
-		if (single_tram != INVALID_DIAGDIR && single_tram != ReverseDiagDir(m_exitdir)) {
-			m_err = EC_NO_WAY;
-			return false;
+		
+		// waypoints are not accessible to other companies
+		if ( IsTileType(m_new_tile, MP_RAILWAY) && IsRailTT() && (GetTileOwner(m_new_tile) != m_veh->owner)) {
+			if (GetRailTileType(m_new_tile) == RAIL_TILE_WAYPOINT) {
+				m_err = EC_NO_WAY;
+				return false;
+			}
 		}
 
 		// road and rail depots can also be entered from one direction only
@@ -233,25 +236,35 @@
 				return false;
 			}
 			// don't try to enter other player's depots
-			if (GetTileOwner(m_new_tile) != m_veh->owner) {
+			if ((GetTileOwner(m_new_tile) != m_veh->owner)&&(!SharedRoadDepots(m_new_tile,m_veh->owner))) {
 				m_err = EC_OWNER;
 				return false;
 			}
 		}
 		if (IsRailTT() && IsDepotTypeTile(m_new_tile, TT())) {
 			DiagDirection exitdir = GetRailDepotDirection(m_new_tile);
-			if (ReverseDiagDir(exitdir) != m_exitdir) {
+			if ((ReverseDiagDir(exitdir) != m_exitdir)||
+					(((GetTileOwner(m_new_tile) != m_veh->owner)&&
+					  (!SharedRailwayDepots(m_new_tile,m_veh->owner))))) {
 				m_err = EC_NO_WAY;
 				return false;
 			}
 		}
 
 		// rail transport is possible only on tiles with the same owner as vehicle
-		if (IsRailTT() && GetTileOwner(m_new_tile) != m_veh->owner) {
+		if (IsRailTT() && (GetTileOwner(m_new_tile) != m_veh->owner) &&
+				(GetTileOwner(m_old_tile) != GetTileOwner(m_new_tile)) && (!SharedTracks(m_new_tile,m_veh->owner))) {
 			// different owner
 			m_err = EC_NO_WAY;
 			return false;
 		}
+		
+		/* single tram bits can only be entered from one direction */
+		DiagDirection single_tram = GetSingleTramBit(m_new_tile);
+		if (single_tram != INVALID_DIAGDIR && single_tram != ReverseDiagDir(m_exitdir)) {
+			m_err = EC_NO_WAY;
+			return false;
+		}
 
 		// rail transport is possible only on compatible rail types
 		if (IsRailTT()) {
@@ -286,6 +299,11 @@
 
 		// special handling for rail stations - get to the end of platform
 		if (IsRailTT() && m_is_station) {
+			if((GetTileOwner(m_new_tile) != m_veh->owner) && (!SharedRailwayStations(m_new_tile,m_veh->owner)))
+			{
+				m_err = EC_NO_WAY;
+				return false;
+			}
 			// entered railway station
 			// get platform length
 			uint length = GetStationByTile(m_new_tile)->GetPlatformLength(m_new_tile, TrackdirToExitdir(m_old_td));
Index: src/players.cpp
===================================================================
--- src/players.cpp	(revision 13683)
+++ src/players.cpp	(working copy)
@@ -241,13 +241,15 @@
 	if (HasBit(1 << EXPENSES_TRAIN_INC    |
 	           1 << EXPENSES_ROADVEH_INC  |
 	           1 << EXPENSES_AIRCRAFT_INC |
-	           1 << EXPENSES_SHIP_INC, cost.GetExpensesType())) {
+	           1 << EXPENSES_SHIP_INC |
+	           1 << EXPENSES_SHARED_INF_INC, cost.GetExpensesType())) {
 		p->cur_economy.income -= cost.GetCost();
 	} else if (HasBit(1 << EXPENSES_TRAIN_RUN    |
 	                  1 << EXPENSES_ROADVEH_RUN  |
 	                  1 << EXPENSES_AIRCRAFT_RUN |
 	                  1 << EXPENSES_SHIP_RUN     |
 	                  1 << EXPENSES_PROPERTY     |
+	                  1 << EXPENSES_SHARED_INF_RUN |
 	                  1 << EXPENSES_LOAN_INT, cost.GetExpensesType())) {
 		p->cur_economy.expenses -= cost.GetCost();
 	}
@@ -558,6 +560,21 @@
 	free(p->num_engines);
 	p->num_engines = CallocT<uint16>(GetEnginePoolSize());
 
+	p->shared_railway_tracks[0] = p->shared_railway_tracks[1] =_settings_game.sharing.shared_railway_tracks;
+	p->shared_railway_stations[0] = p->shared_railway_stations[1] = _settings_game.sharing.shared_railway_stations;
+	p->shared_railway_depots[0] = p->shared_railway_depots[1] = _settings_game.sharing.shared_railway_depots;
+	p->shared_tontile_cost[0] = p->shared_tontile_cost[1] = _settings_game.sharing.shared_tontile_cost;
+	p->shared_road_stops_fee[0] = p->shared_road_stops_fee[1] = 0; // no limit
+	p->shared_harbours_fee[0] = p->shared_harbours_fee[1] = 0; // no limit
+	p->shared_airports[0] = p->shared_airports[1] = _settings_game.sharing.shared_airports;
+	p->shared_landing_fee[0] = p->shared_landing_fee[1] = _settings_game.sharing.shared_landing_fee;
+	p->shared_road_depots[0] = p->shared_road_depots[1] = _settings_game.sharing.shared_road_depots;
+	p->shared_road_stops[0] = p->shared_road_stops[1] = _settings_game.sharing.shared_road_stops;
+	p->shared_water_depots[0] = p->shared_water_depots[1] = _settings_game.sharing.shared_water_depots;
+	p->shared_harbours[0] = p->shared_harbours[1] = _settings_game.sharing.shared_harbours;
+	p->shared_provision[0] = p->shared_provision[1] = _settings_game.sharing.shared_provision;
+	p->shared_change_months = 0;
+
 	return p;
 }
 
@@ -1184,6 +1201,21 @@
 	SLE_CONDVAR(Player, engine_renew_money,    SLE_UINT32,                 16, SL_MAX_VERSION),
 	SLE_CONDVAR(Player, renew_keep_length,     SLE_BOOL,                    2, SL_MAX_VERSION), // added with 16.1, but was blank since 2
 
+	SLE_CONDARR(Player, shared_railway_tracks,   SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_railway_stations, SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_railway_depots,   SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_airports,         SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_road_depots,      SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_road_stops,       SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_water_depots,     SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_harbours,         SLE_BOOL,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_tontile_cost,     SLE_INT16, 2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_road_stops_fee,   SLE_INT8,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_harbours_fee,     SLE_INT8,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_landing_fee,      SLE_INT16, 2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_provision,        SLE_INT8,  2,                SL_VERSION_PATCH, SL_MAX_VERSION),
+	SLE_CONDVAR(Player, shared_change_months,    SLE_INT8,                    SL_VERSION_PATCH, SL_MAX_VERSION),
+
 	/* reserve extra space in savegame here. (currently 63 bytes) */
 	SLE_CONDNULL(63, 2, SL_MAX_VERSION),
 
